/*
** Copyright (C) 2006 Thadeu Lima de Souza Cascardo <cascardo@minaslivre.org>
** Copyright (C) 2009 Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#include <string.h>
#include <depot.h>
#include "usermap.h"

int
usermap_perm (char *user)
{
  static DEPOT* allow_dp = NULL;
  static DEPOT* deny_dp = NULL;
  char* allow = NULL;
  char* deny = NULL;
  if (allow_dp == NULL)
    {
      allow_dp = dpopen ("/var/lib/popproxy/allow.db", DP_OREADER, 0);
    }
  if (deny_dp == NULL)
    {
      deny_dp = dpopen ("/var/lib/popproxy/deny.db", DP_OREADER, 0);
    }
  if (allow_dp)
    allow = dpget (allow_dp, user, -1, 0, -1, NULL);
  if (deny_dp)
    deny = dpget (deny_dp, user, -1, 0, -1, NULL);
  if (allow && deny)
    {
      free (allow);
      free (deny);
      return ACCESS_DENY;
    }
  if (allow)
    {
      free (allow);
      return ACCESS_ALLOW;
    }
  if (deny)
    {
      free (deny);
      return ACCESS_DENY;
    }
  if (!allow_dp)
    return ACCESS_ALLOW;
  return ACCESS_DENY;
}
